#ifndef _fma_map_fabric_h_
#define _fma_map_fabric_h_

#define FMA_MF_INITIAL_XBAR_PORT 15	/* port to use on new dumb xbar */
#define FMA_MF_DFLT_XBAR_PORTS LF_MAX_XBAR_PORTS	/* number of ports to assume */

struct fma_map_progress {

  /* completion routine */
  void (*map_complete_rtn)(struct lf_topo_map *topo_map, int topo_map_size);

  struct lf_nic **my_nics;		/* local NICs */
  int nic_index;			/* current NIC underway */
  int nic_port;				/* current port on this NIC */

  /* Reason code to use in NIC scouts */
  enum lf_nic_scout_reason nic_scout_reason;

  struct fma_xbar xbar_anchor;			/* list of resolved xbars */
  struct fma_xbar unresolved_xbar_anchor;	/* unresolved xbars */
  struct fma_nic  nic_anchor;

  struct lf_xbar *xbar_comparing;	/* current xbar under compare */

  int mf_outstanding_probes;		/* number of pending scout probes */
  int next_node_id;

  /* used to keep track of hosts - there is a 1:1 mapping of max mac addresses
   * to hosts in the fabric
   */
  struct fma_mf_host_record *host_table;	/* table of unique hosts */
  int num_hosts;			/* number of unique macs (hosts) */
  int host_table_size;			/* allocated table size */

  struct lf_topo_map *topo_map;
  int topo_map_size;
};

struct fma_mf_info {
  struct fma_probe_desc mf_probe_anchor;
  int mf_resolved;

  lf_mac_addr_t mf_max_mac_addr;/* MAX MAC address on host owning this NIC */
};

struct fma_mf_host_record {
  lf_mac_addr_t max_mac;	/* unique identifier for this host */
  int num_nics;			/* NICs so far */
};

/*
 * prototypes
 */
void fma_mf_got_compare_resp(struct lf_myri_packet *pkt);

#endif /* _fma_map_fabric_h_ */
