/*
 * Routines for running in standalone mode
 */

#include "fma_myri.h"

#define FMA_MAP_WAIT_TIMEOUT (60*1000)

#define FMA_FMS_MAPPER_LEVEL 100	/* FMS mappers have highest level */

/*
 * Data specific to standalone mode
 */
struct fma_standalone_data {
  int active;				/* true if i am the "active" mapper */
  int my_level;
  lf_mac_addr_t my_max_mac;

  struct lf_topo_map *topo_map;		/* standalone topo map */
  int topo_map_size;

  int mapper_level;
  lf_mac_addr_t mapper_mac;		/* MAC addr of mapper if not me */
  struct lf_host *mapper_host;
  uint8_t mapper_route[MAX_FMA_ROUTE_LEN];
  int mapper_route_len;
  struct fma_nic_info *mapper_route_nic; /* NIC handle to use */
  int mapper_route_port;

  int map_send_id;
  int map_sends_pending;

  struct lf_event *map_wait_timer;	/* timer for waiting for a map */
};

/*
 * prototypes
 */
void fma_enter_standalone_mode(void);
void fma_exit_standalone_mode(void);
void fma_standalone_myrinet_ready(void);
void fma_standalone_got_contact(int level, lf_mac_addr_t mac_addr,
	struct fma_nic_info *nic, int port, uint8_t *route, int route_len,
	int is_lost);
void fma_standalone_map_done(struct lf_topo_map *, int);
