/*
 * Translate column names into column indices
 */

#include "libfma.h"
#include "lf_internal.h"
#include "lf_db.h"

/*
 * Given a "column descriptor array" get column indices for each column label
 */
int
lf_get_column_indices(
  db_table_ptr_t tp,
  struct lf_col_desc *cdp,
  int ncols,
  int *colid,
  char *name)
{
  int rc;
  int c;

  /* get the column indices */
  for (c=0; c<ncols; ++c) {
    db_datum_type_t type;

    rc = db_get_column_info(tp, cdp[c].name,
                            &colid[c], &type);
    if (rc == -1) {
      LF_ERROR(("Missing column \"%s\" in %s table.", cdp[c].name, name));
    }
    if (type != cdp[c].type) {
      LF_ERROR(("Column \"%s\" in %s has wrong type(%d), should be %d.",
                 cdp[c].name, name, type, cdp[c].type));
    }
  }
  return 0;

 except:
  return -1;
}

